@page "/inventory"

@using AntDesign
@using System.ComponentModel
@using System.Text;
@using System.Net;
@using FIOWebServer.Models
@using FIOWebServer.JsonPayloads
@using Newtonsoft.Json
@using CurrieTechnologies.Razor.Clipboard

@inject ClipboardService Clipboard
@inject IMatToaster Toaster
@inject NavigationManager NavManager
@inject GlobalAppState GlobalAppState

@implements IDisposable

<h1>Inventory</h1>
<FIOWebServer.Components.LoadingWrapper RequiresAuth="true" @bind-ProgressCount="@ProgressCount" @bind-TotalProgress="@TotalProgress">
    <div style="position:absolute; top: 75px; right: 30px">
        <table cellspacing="0" cellpadding="2">
            <tr>
                <td><b>Bases:</b></td>
                <td>@BaseCount</td>
            </tr>
            <tr>
                <td><b>Warehouses:</b></td>
                <td>@WarehouseCount</td>
            </tr>
            <tr>
                <td><b>Ships:</b></td>
                <td>@ShipCount</td>
            </tr>
        </table>
    </div>
 
    <MatIconButton Style="outline:0" Icon="refresh" OnClick="@(() => { _ = Refresh(); })"></MatIconButton>
    <FIOWebServer.Components.UserOrGroup AllowancesRequired="@RequiredAllowances" @bind-CurrentUserName="ActiveUserName" UserNameSelectionChanged="@Refresh"/>
    
    <br/>
    <div>
        <Checkbox Style="margin-bottom:10px; margin-right:10px" Checked="@ShowEmptyStorage" CheckedChange="@(() => {ShowEmptyStorage = !ShowEmptyStorage;})">Show Empty Storages</Checkbox>
        <Checkbox Style="margin-bottom:10px; margni-right:10px" Checked="@ShowShipFuelTanks" CheckedChange="@(() => {ShowShipFuelTanks = !ShowShipFuelTanks;})">Show Ship Fuel Tanks</Checkbox>
    </div>
    <Input MaxLength="3" Placeholder="Search Ticker" @bind-Value="@SearchString"/>
    <Table DataSource="filteredInventory"
          TreeChildren="item => item.Children"
          PageSize="100"
          Size=@TableSize.Small
          TItem="InventoryModel"
          Bordered="true">
              <Column Width="200" @bind-Field="@context.LocationIdentifier" Title="Location" Sortable>
                  <a href="" @onclick="@(() => { _ = CopyBufferCommandToClipboard(context.StorageIdCommand);})" @onclick:preventDefault>@context.LocationDisplay</a>
                    @if (!string.IsNullOrWhiteSpace(context.LocationDisplay) )
                    {
                        <Popover Placement="@Placement.RightTop" Title="">
                            <ContentTemplate>
                                Retrieval Time: @(context.LastUpdate.ToLocalTime())
                            </ContentTemplate>
                            <ChildContent>
                                <MatIcon style="transform:scale(0.6)" Icon="av_timer"/>    
                            </ChildContent>
                        </Popover>
                    }
              </Column>
              <Column Width="100" @bind-Field="@context.StorageType" Title="Storage Type" Sortable>
                  @context.StorageType
              </Column>
              <Column Width="100" TData="string" Title="Ticker" Sortable="false">
                  @context.MaterialName
              </Column>
              <Column Width="75" TData="string" Title="Amount" Sortable="false">
                  @(@context.Units != null ? ((int)context.Units).ToString() : "")
              </Column>
          </Table>
</FIOWebServer.Components.LoadingWrapper>